<template>
    <div>
        <div class="container-fluid">
            <div class="card row">
                <div class="col-md-12  w3-center card white-box">
                    {{sondage.titre}}
                </div>
                <div class="col-md-12 shadow card white-box w3-center">
                    <div v-if="firstlaunch" class="">
                        <button type="button" @click="nextQ">commencer</button>
                    </div>
                    <div v-if=" nextQuestion >= 0">

                        <div class="row">
                            <div class="col-md-2">
                                <span class="w3-badge w3-xxlarge pull-center">{{nextQuestion + 1}}</span>
                            </div>
                            <div class="col-md-8">
                                <h2>{{questionNav[nextQuestion].titre_question}}</h2>
                            </div>
                        </div>
                        <div v-if="questionNav[nextQuestion].type_reponse_id === 1" class="row">
                            <hr>
                            <div class="row" style="width : 80%; margin-left : auto; margin-right : auto">
                                <div class="col-md-1"></div>
                                <div class="col-md-2 row btn btn-default w3-margin"
                                     v-for="opt in questionNav[nextQuestion].options">
                                    <option_one :option="opt"
                                                :key="questionNav[nextQuestion].id"
                                                @nextStep="nextStep(opt)"></option_one>
                                </div>
                            </div>
                        </div>
                        <div v-if="questionNav[nextQuestion].type_reponse_id ===2" class="row">
                            <hr>
                            <div class="col-md-2"></div>
                            <div class="row col-md-10" style="margin-left : auto; margin-right : auto">
                                <div class="col-md-3 row m-10"
                                     v-for="opt in questionNav[nextQuestion].options">
                                    <qcm_texte :option="opt" class=""
                                               :key="questionNav[nextQuestion].id"
                                               @nextStep="nextStep(opt)"></qcm_texte>
                                </div>
                            </div>
                        </div>
                        <div v-if="questionNav[nextQuestion].type_reponse_id === 4" class="row">
                            <hr>
                            <div class="col-md-2"></div>
                            <div class="row col-md-10" style="margin-left : auto; margin-right : auto">
                                <div class="col-md-12">
                                    <div class="row p-20">
                                        <div class="col-md-5 row "
                                             v-for="opt in questionNav[nextQuestion].options">
                                            <trueordare :option="opt" class=""
                                                        :key="questionNav[nextQuestion].id"
                                                        @nextStep="nextStep(opt)"></trueordare>
                                        </div>

                                    </div>
                                </div>
                            </div>
                        </div>
                        <div v-if="questionNav[nextQuestion].type_reponse_id === 5" class="row">
                            <hr>
                            <div class="col-md-2"></div>
                            <div class="row col-md-10" style="margin-left : auto; margin-right : auto">
                                <div class="col-md-12">
                                    <div class="row p-20">
                                        <div class="col-md-12">
                                            <date-picker v-model="date" class="form-control"
                                                         format="dd-MM-yyyy"></date-picker>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div v-if="questionNav[nextQuestion].type_reponse_id === 6" class="row">
                            <hr>
                            <div class="col-md-2"></div>
                            <div class="row col-md-10" style="margin-left : auto; margin-right : auto">
                                <div class="col-md-12">
                                    <div class="row p-20">
                                        <div class="col-md-12">
                                            <input type="text" v_model="textfield" class="form-control"/>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div v-if="questionNav[nextQuestion].type_reponse_id === 7" class="row">
                            <hr>
                            <div class="col-md-2"></div>
                            <div class="row col-md-10" style="margin-left : auto; margin-right : auto">
                                <div class="col-md-12">
                                    <div class="row p-20">
                                        <div class="col-md-12">
                                            <vue-mask
                                                    class="form-control"
                                                    v-model="number"
                                                    :value="number"
                                                    mask="000000">
                                            </vue-mask>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div v-if="questionNav[nextQuestion].type_reponse_id === 8" class="row">
                            <hr>
                            <div class="col-md-2"></div>
                            <div class="row col-md-10" style="margin-left : auto; margin-right : auto">
                                <div class="col-md-12">
                                    <div class="row p-20">
                                        <div class="col-md-12">
                                            <input type="text" v-model="textname" placeholder="votre nom et prenom"
                                                   class="form-control"/>
                                        </div>
                                        <div class="col-md-12">
                                            <input type="text" v-model="email" placeholder="votre adresse email"
                                                   class="form-control"/>
                                        </div>
                                        <div class="col-md-12">
                                            <input type="text" v-model="contact" placeholder="votre contact"
                                                   class="form-control"/>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <button type="button" @click="backQ">precedent</button>
                        <button type="button" @click="nextQ">next</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import Option_one from "./option_one";
    import Trueordare from "./trueordare";
    import VueMask from "vue-jquery-mask/src/component";
    import Datepicker from "vuejs-datepicker";
    import axios from 'axios';


    export default {

        components: {
            Trueordare,
            Option_one,
            'date-picker': Datepicker,
            VueMask,
        },
        props: ['questions', 'sondages'],
        data() {
            return {
                nextQuestion: -1,
                sondage: JSON.parse(this.sondages),
                number: null,
                date: null,
                questionCount: 0,
                textfield: '',
                textname: '',
                email: '',
                contact: '',
                firstlaunch: true,
                setQuestion: false,
                questionNav: [],
                question: this.questions,
                titre: sondage.titre,
            }

        },
        methods: {
            nextStep(opt) {
                if (this.firstlaunch) {
                    this.firstlaunch = false;
                } else {
                    this.questionNav[this.nextQuestion].answer = opt.id;
                    console.log(this.questionNav[this.nextQuestion]);
                    if (opt.has_subquestion === 1) {
                        for (let i = 0; i < this.sondage.questions.length; i++) {
                            if (this.sondage.questions[i].id === opt.sousquestions) {
                                if (this.questionNav[this.questionNav.length - 1].id === opt.sousquestions) {
                                    break;
                                }
                                this.questionNav.splice(this.nextQuestion + 1, 0, this.sondage.questions[i]);
                                return this.nextQuestion++;
                            }
                        }
                    } else {
                        if (this.nextQuestion >= this.questionNav.length - 1 && !this.firstlaunch) {
                            console.log('running');
                            console.log(this.questionNav);
                            this.postRep(this.questionNav);
                            return false;
                        }
                        return this.nextQuestion++;
                    }
                }
            },
            postRep(questions) {
                console.log(JSON.stringify(questions));
                axios.post('http://127.0.0.1:8000/api/web/saverep/',
                    {question: JSON.stringify(questions)}, // the data to post
                    {
                        headers: {
                            'Content-type': 'application/json;charset=UTF-8',
                        }
                    }).then(response => {
                    console.log(response);
                }).catch(error =>{
                    console.log(error);
                });
            },
            nextQ() {
                if (this.nextQuestion >= this.questionNav.length - 1 && !this.firstlaunch) {
                    console.log('running');
                    this.postRep(this.questionNav);
                    return false;
                } else {
                    if (this.nextQuestion >= 0) {
                        if (this.questionNav[this.nextQuestion].type_reponse_id === 5) {
                            this.questionNav[this.nextQuestion].answer = this.date;
                        } else if (this.questionNav[this.nextQuestion].type_reponse_id === 6) {
                            this.questionNav[this.nextQuestion].answer = this.textfield;
                        } else if (this.questionNav[this.nextQuestion].type_reponse_id === 7) {
                            this.questionNav[this.nextQuestion].answer = this.number;
                        }
                        else if (this.questionNav[this.nextQuestion].type_reponse_id === 8) {
                            this.questionNav[this.nextQuestion].nom = this.textname;
                            this.questionNav[this.nextQuestion].email = this.email;
                            this.questionNav[this.nextQuestion].contact = this.contact;
                        }
                    }
                    console.log(this.questionNav);
                    console.log('next is launching');
                    console.log(this.nextQuestion);
                    console.log(this.questionNav.length);
                    this.firstlaunch = false;
                    return this.nextQuestion++;
                }
            },
            backQ() {
                if (this.nextQuestion !== 0)
                    this.nextQuestion--;
                if (this.questionNav[this.nextQuestion + 1].is_sousquestion === 1) {
                    console.log('sous-question' + this.nextQuestion);
                    this.questionNav.splice(this.nextQuestion + 1, 1);
                }
            }
        },
        watch: {
            questionNav: function () {

            },
            nextQuestion: function () {

                if (this.nextQuestion === 0 && !this.setQuestion) {
                    this.setQuestion = true;
                    for (let i = 0; i < this.sondage.questions.length; i++) {
                        if (this.sondage.questions[i].is_sousquestion === 0) {
                            this.questionNav.push(this.sondage.questions[i]);
                        }
                    }
                }

            }
        },
        name: "sondage",
    }
    ;
</script>

<style scoped>

</style>